# coding: utf-8

from flask import Flask
from xeger import xeger
from flask import request

app = Flask(__name__)

@app.route('/')
def hello_world():
    return '''
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>rozwijanie wzorów</title>
</head>
<body>
    <p>
        Oto program do rozwijania regekspów. Dajesz mu regekspa, a on generuje losowe
        napisy pasujące do tego regekspa. Zajmuje to nawet kilkanaście sekund, więc bądź cierpliwy.
    </p>
    <p>
        Możesz spróbować wygenerować <a href='rozwin?ile=10&wzor=%5Cd%5Cd-%5Cd%5Cd%5Cd'>kody pocztowe</a>,
        <a href='rozwin?wzor=(Darka|Tomka|Wojtka|Mirka)+((siostry|brata|corki|syna|ojca|matki|zony|szwagra|szwagierki|ziecia|tescia|tesciowej|wujka|stryjka|ciotki)+)*(siostra|brat|corka|syn|ojciec|matka|zona|szwagier|szwagierka|ziec|tesc|tesciowa|wujek|stryjek|ciotka)&ile=10'>opisy pokrewieństwa</a>
        albo co tam chcesz.
    </p>
    <form action="rozwin">
        wzór (nie używaj w nim polskich liter): <input type="text" style="width:30em" name="wzor"><br>
        ile wygenerować (nie wpisuj więcej niż 500, bo i tak nie wygeneruję więcej niż 500): <input type="text" name="ile" value="20"><br>
        <button type="submit">rozwiń</button>
    </form>
</body>
</html>
    '''

@app.route('/rozwin')
def rozwin():
    wzor = request.args.get('wzor')
    ile = int(request.args.get('ile'))
    #ile = ile if ile < 500 else 500
    napisy = '<ul><li>' + '\n<li>'.join(set([xeger(wzor) for i in xrange(ile)])) + '</ul>'
    return napisy

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=5000)
